;
;boot.s -- Kernel start location
;
MBOOT_PAGE_ALIGN equ 1<<0
MBOOT_MEM_INFO   equ 1<<1
MBOOT_FLAG_ELF   equ 1<<5
MBOOT_HEADER_MAGIC equ 0X1BADB002
MBOOT_HEADER_FLAGS equ MBOOT_PAGE_ALIGN | MBOOT_MEM_INFO
MBOOT_CHECKSUM equ -(MBOOT_HEADER_MAGIC + MBOOT_HEADER_FLAGS)

bits 32

section .text

global mboot
extern code
extern bss
extern end

mboot:
    dd MBOOT_HEADER_MAGIC
    dd MBOOT_HEADER_FLAGS
    dd MBOOT_CHECKSUM
    dd mboot
        dd code
        dd bss
        dd end
        dd start
global start
extern kernel_main

start:
    cli
    mov esp,stack
    push ebx    ;multiboot
    push eax    ;magic
    mov ebp,0

    call kernel_main
    add esp,8
    jmp $
.end:

global switch_to_user_mode
switch_to_user_mode:
    cli
	mov ax, 0x23
	mov ds, ax
	mov es, ax
	mov fs, ax
	mov gs, ax

	mov eax, esp
	push 0x23   ;ss
	push eax    ;esp
	pushfd       ;eflags
	push 0x1B   ;cs
	push .mode
	iret
.mode:


section .bss
    resb 32768
stack:
