//common.c -- Define some global functions
#include "common.h"
#include "monitor.h"
void outb(uint16_t port, uint8_t value)
{
    asm volatile("outb %1,%0"::"dN"(port),"a"(value));
}

uint8_t inb(uint16_t port)
{
    uint8_t ret;
    asm volatile("inb %1,%0":"=a"(ret):"dN"(port));
    return ret;
}

uint16_t inw(uint16_t port)
{
    uint16_t ret;
    asm volatile("inw %1,%0":"=a"(ret):"dN"(port));
    return ret;
}

void memcpy(uint8_t *dest, const uint8_t *src, uint32_t len)
{
    for(; len!=0; len--)
        *dest++ = *src++;
}

void memset(void *dest, uint8_t val, uint32_t len)
{
    char *tmp = (char*)dest;
    for(; len!=0; len--)
        *tmp++ = val;
}

size_t strlen(char *src)
{
    size_t i = 0;
    while(*(src++) != '\0')
        i++;
    return i;
}

// =:0  <:-1   >:1
int strcmp(const char *str1, const char *str2)
{
    while(*str1 && *str2 && (*str1 == *str2))
    {
        str1++;
        str2++;
    }


    if(*str1=='\0' && *str2=='\0')
    {
        return 0;
    }

    if(*str1 < *str2)
        return -1;
    else
        return 1;
}

int atoi(const char *str)
{
    int len = 0;
    int i;
    int result = 0;
    //get the length
    for(i=0; i<len; i++)
    {
        if(str[i] != '\0')
            len++;
    }

    int negative = 0;
    if(str[0] == '-')
    {
        i = 1;
        negative = 1;
        len--;
    }
    else
    {
        i = 0;
        negative = 0;
    }

    for(; str[i] != '\0'; i++)
    {
        result += pow(10,--len);
    }

    return result;
}

//unsigned int
void itoa(uint32_t n, char *str, int radix)
{
    const char ascii[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";

    // init
    str[0] = '+';

    //negative integer
    if(n < 0 )
    {
        n = 0-n;
        str[0] = '-';
    }

    int i,j;
    for(i=1; n>0; i++,n/=radix)
    {
        str[i] = ascii[n % radix];

    }

    str[i] = '\0';

    //reverse array
    for(j=i-1,i=1; j>i; j--,i++)
    {
        //swap two integer
        str[i] = str[i] ^ str[j];
        str[j] = str[i] ^ str[j];
        str[i] = str[i] ^ str[j];
    }

    // if n>0 then move left 1 bit
    if(str[0] != '-')
    {
        for(i=0; str[i] != '\0'; i++)
            str[i] = str[i+1];
    }
}

// n^m
int pow(int n, int m)
{
    int result = 1;

    if(m<0)
        ;   //panic
    else
    {
       int i;
       for(i=0; i<m; i++)
            result *= n;
        return result;
    }

    return result;
}
