// common.h -- Defines typedefs and some global functions

#ifndef COMMON_H
#define COMMON_H

typedef unsigned int uint32_t;
typedef           int int32_t;
typedef unsigned short uint16_t;
typedef          short int16_t;
typedef unsigned char uint8_t;
typedef          char int8_t;

typedef unsigned int  size_t;

void outb(uint16_t port, uint8_t value);
uint8_t inb(uint16_t port);
uint16_t inw(uint16_t port);

void memcpy(uint8_t *dest, const uint8_t *src, uint32_t len);
void memset(void *dest, uint8_t val, uint32_t len);
size_t strlen(char *src);
int strcmp(const char *str1, const char *str2);

void itoa(uint32_t n, char *str, int radix);
int atoi(const char *str);
int pow(int n, int m);

#endif
