// gdt.h --
#ifndef GDT_H
#define GDT_H

#include "common.h"

typedef struct
{
    uint16_t limit_low;
    uint16_t base_low;
    uint8_t base_middle;
    uint8_t access;
    uint8_t granularity;
    uint8_t base_high;
}__attribute__((packed)) gdt_entry_t;

//access format
// 7 6..5  4  3..0
// P DPL  DT  Type

//graunlarity format
// 7 6 5 4 3..0
// G D 0 A segment length(19..16)

typedef struct
{
    uint16_t limit;
    uint32_t base;
}__attribute__((packed)) gdt_ptr_t;

//Initialisation gdt
void init_gdt();

#endif


