#include "panic.h"
#include "common.h"
#include "elf.h"
#include "printk.h"

static void print_stack_trace();

extern elf_t kernel_elf;

void panic(const char* msg)
{
    printk("System Panic: %s\n", msg);
    print_stack_trace();
    for(;;);
}

void print_stack_trace()
{
    uint32_t *ebp, *eip;
    asm volatile("mov %%ebp, %0":"=r"(ebp));
    while(ebp)
    {
        eip = ebp+1;
        //printk has a bug, seem occur on empty string
        //printk("%s\t(%x) \n",elf_lookup_symbol (*eip, &kernel_elf), eip);
        ebp = (uint32_t*)*ebp;
        monitor_write(elf_lookup_symbol (*eip, &kernel_elf));
        monitor_write(":");
        monitor_write_hex((uint32_t)eip);
        monitor_write("\n");
    }
    printk("\n");
}
