#ifndef PMM_H
#define PMM_H

#include "common.h"

#define PMM_STACK_ADDR 0xFF000000

//return the address of a page of physical memory
uint32_t pmm_alloc_page();

//informs that the given page address as no longer used
void pmm_free_page(uint32_t p);

//the vmm should set this to 1 when it is fully booted
extern char pmm_paging_active;

#define PAGE_PRESENT 0x1
#define PAGE_WRITE 0x2
#define PAGE_USER 0x4
#define PAGE_MASK 0xFFFFF000

void init_pmm(uint32_t start);

void map(uint32_t va, uint32_t pa, uint32_t flags);

void unmap(uint32_t va);


#endif
