//
#include "stdarg.h"
#include "monitor.h"
#include "common.h"
#include "panic.h"

void printk(const char *fmt, ...)
{
    //%c, %s, %d, %x %%
    char buff[1024];
    char *tmp;

    va_list arg_ptr;
    va_start(arg_ptr, fmt);

    int i,j;

    for(i=0,j=0; *(fmt+i) != '\0'; i++)
    {
        if(fmt[i] != '%')
        {
            buff[j] = fmt[i];
            j++;
        }
        else
        {
            switch(fmt[++i])
            {
                case 'c' :
                    buff[j] = (char)va_arg(arg_ptr, int); // push int
                    j++;
                    break;
                case '%' :
                    buff[j] = '%';
                    j++;
                    break;
                case 's' :
                    tmp = va_arg(arg_ptr, char*);
                    memcpy(&buff[j], tmp, strlen(tmp));
                    j+=strlen(tmp);
                    break;
                case 'd' :
                    itoa(va_arg(arg_ptr, uint32_t), (char*)tmp, 10);
                    memcpy(&buff[j], tmp, strlen(tmp));
                    j+=strlen(tmp);
                    break;
                case 'x' :
                    buff[j++] = '0';
                    buff[j++] = 'x';
                    itoa(va_arg(arg_ptr, uint32_t), (char*)tmp, 16);
                    memcpy(&buff[j], tmp, strlen(tmp));
                    j+=strlen(tmp);
                    break;
                default :
                    monitor_write("error format.");
                    for(;;);
            }
        }
    }

    buff[j] = '\0';
    va_end(arg_ptr);
    monitor_write(buff);
}

//clear screen
void printk_clear()
{
    monitor_clear();
}


