#include "syscall.h"
#include "idt.h"
#include "monitor.h"

static void syscall_handler(registers_t *regs);

DEFN_SYSCALL1(monitor_write, 0, char*);
DEFN_SYSCALL1(monitor_write_hex, 1, int);
DEFN_SYSCALL1(monitor_write_dec, 2, int);

//int syscall_monitor_write_hex(int p1)
//{
//     int a;
//     asm volatile("int $0x80" : "=a"(a) : "0"(1), "b"((int)p1));
//     return a;
//};

static void *syscalls[3] =
{
    &monitor_write,
    &monitor_write_hex,
    &monitor_write_dec,
};

uint32_t num_syscalls = 3;

void initialize_syscalls()
{
    register_interrupt_handler(0x80, &syscall_handler);
}

void syscall_handler(registers_t *regs)
{
    if(regs->eax >= num_syscalls)
        return;

    void *location = syscalls[regs->eax];

    int ret;
    asm volatile (" \
     push %1; \
     push %2; \
     push %3; \
     push %4; \
     push %5; \
     call *%6; \
     pop %%ebx; \
     pop %%ebx; \
     pop %%ebx; \
     pop %%ebx; \
     pop %%ebx; \
    " : "=a"(ret) : "r"(regs->edi), "r" (regs->esi), "r" (regs->edx), "r" (regs->ecx), "r" (regs->ebx), "r" (location));
    regs->eax = ret;
}



